diff --git a/ldap/servers/plugins/replication/cl5_api.c b/ldap/servers/plugins/replication/cl5_api.c
index 89ae995..7320316 100644
--- a/ldap/servers/plugins/replication/cl5_api.c
+++ b/ldap/servers/plugins/replication/cl5_api.c
@@ -1596,10 +1411,11 @@ cl5DestroyReplayIterator(CL5ReplayIterator **iterator)
 
     clcache_return_buffer(&(*iterator)->clcache);
 
+    /* TBD lock/unlock cldb ?
     if ((*iterator)->fileObj) {
         object_release((*iterator)->fileObj);
         (*iterator)->fileObj = NULL;
-    }
+    } */
 
     /* release supplier's ruv */
     if ((*iterator)->supplierRuvObj) {
@@ -1624,39 +1440,6 @@ cl5DeleteOnClose(PRBool rm)
     s_cl5Desc.dbRmOnClose = rm;
 }
 
-/* Name:        cl5GetDir
-   Description:    returns changelog directory
-   Parameters:  none
-   Return:        copy of the directory; caller needs to free the string
- */
-char *
-cl5GetDir()
-{
-    if (s_cl5Desc.dbDir == NULL) {
-        return NULL;
-    } else {
-        return slapi_ch_strdup(s_cl5Desc.dbDir);
-    }
-}
-
-/* Name: cl5Exist
-   Description: checks if a changelog exists in the specified directory;
-                We consider changelog to exist if it contains the dbversion file.
-   Parameters: clDir - directory to check
-   Return: 1 - if changelog exists; 0 - otherwise
- */
-PRBool
-cl5Exist(const char *clDir)
-{
-    char fName[MAXPATHLEN + 1];
-    int rc;
-
-    PR_snprintf(fName, MAXPATHLEN, "%s/%s", clDir, VERSION_FILE);
-    rc = PR_Access(fName, PR_ACCESS_EXISTS);
-
-    return (rc == PR_SUCCESS);
-}
-
 /* Name: cl5GetOperationCount
    Description: returns number of entries in the changelog. The changelog must be
                 open for the value to be meaningful.
@@ -1666,10 +1449,8 @@ cl5Exist(const char *clDir)
  */
 
 int
-cl5GetOperationCount(Object *replica)
+cl5GetOperationCount(Replica *replica)
 {
-    Object *obj;
-    CL5DBFile *file;
     int count = 0;
     int rc;
 
@@ -1686,46 +1467,39 @@ cl5GetOperationCount(Object *replica)
 
     if (replica == NULL) /* compute total entry count */
     {
-        obj = objset_first_obj(s_cl5Desc.dbFiles);
+        /* TBD get count for all bacjebds */
+        /* obj = objset_first_obj(s_cl5Desc.dbFiles);
         while (obj) {
             file = (CL5DBFile *)object_get_data(obj);
             PR_ASSERT(file);
             count += file->entryCount;
             obj = objset_next_obj(s_cl5Desc.dbFiles, obj);
-        }
+        }*/
+        count = 0;
     } else /* return count for particular db */
     {
-        /* select correct db file */
-        rc = _cl5GetDBFile(replica, &obj);
-        if (rc == CL5_SUCCESS) {
-            file = (CL5DBFile *)object_get_data(obj);
-            PR_ASSERT(file);
-
-            count = file->entryCount;
-            slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                          "cl5GetOperationCount - Found DB object %p\n", obj);
-            object_release(obj);
+        cldb_Handle *cldb = replica_get_file_info(replica);
+        if (cldb) {
+            count = cldb->entryCount;
         } else {
-            slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                          "cl5GetOperationCount - Could not get DB object for replica\n");
-            count = 0;
+            /* replica is not enabled */
+            count = -1;
         }
     }
 
     _cl5RemoveThread();
     return count;
+	
 }
 
 /***** Helper Functions *****/
 
 /* this call happens under state lock */
 static int
-_cl5Open(const char *dir, const CL5DBConfig *config, CL5OpenMode openMode)
+_cl5Open(const CL5DBConfig *config, CL5OpenMode openMode)
 {
     int rc;
 
-    PR_ASSERT(dir);
-
     /* setup db configuration parameters */
     if (config) {
         _cl5SetDBConfig(config);
@@ -1741,35 +1515,14 @@ _cl5Open(const char *dir, const CL5DBConfig *config, CL5OpenMode openMode)
         goto done;
     }
 
-    /* create the changelog directory if it does not exist */
-    rc = cl5CreateDirIfNeeded(dir);
-    if (rc != CL5_SUCCESS) {
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                      "_cl5Open - Failed to create changelog directory (%s)\n", dir);
-        goto done;
-    }
-
-    if (s_cl5Desc.dbDir) {
-        slapi_ch_free_string(&s_cl5Desc.dbDir);
-    }
-    s_cl5Desc.dbDir = slapi_ch_strdup(dir);
-
-    /* check database version */
-    rc = _cl5CheckDBVersion();
-    if (rc != CL5_SUCCESS) {
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl, "_cl5Open - Invalid db version\n");
-        goto done;
-    }
-
-    s_cl5Desc.dbOpenMode = openMode;
-
-    /* initialize db environment */
     rc = _cl5AppInit();
     if (rc != CL5_SUCCESS) {
         slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
                       "_cl5Open - Failed to initialize db environment\n");
         goto done;
     }
+	
+    replica_enumerate_replicas(nCL_SetReplicaDB, NULL);
 
     /* init the clcache */
     if ((clcache_init(&s_cl5Desc.dbEnv) != 0)) {
@@ -1796,56 +1549,53 @@ done:;
 }
 
 int
-cl5CreateDirIfNeeded(const char *dirName)
+nCL_UnSetReplicaDB(Replica *replica, void *arg)
 {
-    int rc;
-    char buff[MAXPATHLEN + 1];
-    char *t;
-
-    PR_ASSERT(dirName);
-
-    rc = PR_Access(dirName, PR_ACCESS_EXISTS);
-    if (rc == PR_SUCCESS) {
-        return CL5_SUCCESS;
-    }
-
-    /* directory does not exist - try to create */
-    PL_strncpyz(buff, dirName, sizeof(buff) - 1);
-    t = strchr(buff, '/');
+    int rc = 0;
+    cldb_Handle *cldb = replica_get_file_info(replica);
 
-    /* skip first slash */
-    if (t) {
-        t = strchr(t + 1, '/');
+    if (cldb == NULL) {
+        slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
+                      "nCL_UnSetReplicaDB: cldb is NULL\n");
+        return -1;
     }
+    rc = replica_set_file_info(replica, NULL);
+    slapi_ch_free_string(&cldb->ident);
+    slapi_ch_free((void **)&cldb);
 
-    while (t) {
-        *t = '\0';
-        if (PR_Access(buff, PR_ACCESS_EXISTS) != PR_SUCCESS) {
-            rc = PR_MkDir(buff, DIR_CREATE_MODE);
-            if (rc != PR_SUCCESS) {
-                slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                              "cl5CreateDirIfNeeded - Failed to create dir (%s); NSPR error - %d\n",
-                              dirName, PR_GetError());
-                return CL5_SYSTEM_ERROR;
-            }
-        }
+    return rc;
 
-        *t++ = FILE_PATHSEP;
+}
 
-        t = strchr(t, '/');
+int
+nCL_SetReplicaDB(Replica *replica, void *arg)
+{
+    DB *pDB = NULL;
+    if (!replica_is_flag_set(replica, REPLICA_LOG_CHANGES)) {
+        /* replica does not have a changelog */
+        return 0;
     }
+    cldb_Handle *cldb = replica_get_file_info(replica);
+    Slapi_Backend *be = slapi_be_select(replica_get_root(replica));
+    Object *ruv_obj = replica_get_ruv(replica);
+    int rc = -1;
 
-    /* last piece */
-    rc = PR_MkDir(buff, DIR_CREATE_MODE);
-    if (rc != PR_SUCCESS) {
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                      "cl5CreateDirIfNeeded - Failed to create dir; NSPR error - %d\n",
-                      PR_GetError());
-        return CL5_SYSTEM_ERROR;
+    rc = slapi_back_get_info(be, BACK_INFO_DBENV_CLDB, (void **)&pDB);
+    if (rc == 0) {
+        cldb = (cldb_Handle *)slapi_ch_calloc(1, sizeof(cldb_Handle));
+        cldb->db = pDB;
+        cldb->ident = ruv_get_replica_generation ((RUV*)object_get_data (ruv_obj));
+        _cl5ReadRUV(cldb, PR_TRUE);
+        _cl5ReadRUV(cldb, PR_FALSE);
+        _cl5GetEntryCount(cldb);
     }
-
-    return CL5_SUCCESS;
+    slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
+        "nCL_SetReplicaDB: cldb is set\n");
+    rc = replica_set_file_info(replica, cldb);
+ 
+    return rc;
 }
+ 
 
 static int
 _cl5AppInit(void)
@@ -1892,81 +1642,6 @@ _cl5AppInit(void)
 static int
 _cl5DBOpen()
 {
-    PRBool dbFile;
-    PRDir *dir;
-    PRDirEntry *entry = NULL;
-    int rc = -1; /* initialize to failure */
-    Object *replica;
-    int count = 0;
-
-    /* create lock that guarantees that each file is only added once to the list */
-    s_cl5Desc.fileLock = PR_NewLock();
-
-    /* loop over all db files and open them; file name format is cl5_<dbid>.<dbext>    */
-    dir = PR_OpenDir(s_cl5Desc.dbDir);
-    if (dir == NULL) {
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                      "_cl5DBOpen - Failed to open changelog dir; NSPR error - %d\n",
-                      PR_GetError());
-        return CL5_SYSTEM_ERROR;
-    }
-
-    /* initialize set of db file objects */
-    s_cl5Desc.dbFiles = objset_new(NULL);
-    while (NULL != (entry = PR_ReadDir(dir, PR_SKIP_DOT | PR_SKIP_DOT_DOT))) {
-        if (NULL == entry->name) {
-            break;
-        }
-
-        dbFile = _cl5FileName2Replica(entry->name, &replica);
-        if (dbFile) /* this is db file, not a log or dbversion; those are just skipped */
-        {
-            /* we only open files for existing replicas */
-            if (replica) {
-                rc = _cl5DBOpenFile(replica, NULL /* file object */,
-                                    PR_FALSE /* check for duplicates */);
-                if (rc != CL5_SUCCESS) {
-                    slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl, "_cl5DBOpen - "
-                                                                       "Error opening file %s\n",
-                                  entry->name);
-                    return rc;
-                }
-
-                object_release(replica);
-                count++;
-            } else /* there is no matching replica for the file - remove */
-            {
-                char fullpathname[MAXPATHLEN];
-                slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl, "_cl5DBOpen - "
-                                                                   "File %s has no matching replica; removing\n",
-                              entry->name);
-
-                PR_snprintf(fullpathname, MAXPATHLEN, "%s/%s", s_cl5Desc.dbDir, entry->name);
-                rc = s_cl5Desc.dbEnv->dbremove(s_cl5Desc.dbEnv,
-                                               0, fullpathname, 0,
-                                               DEFAULT_DB_ENV_OP_FLAGS);
-                if (rc != 0) {
-                    slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                                  "_cl5DBOpen - Failed to remove (%s) file; "
-                                  "libdb error - %d (%s)\n",
-                                  fullpathname, rc, db_strerror(rc));
-                    if (PR_Delete(fullpathname) != PR_SUCCESS) {
-                        PRErrorCode prerr = PR_GetError();
-                        slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                                      "_cl5DBOpen - Failed to remove (%s) file; "
-                                      "nspr error - %d (%s)\n",
-                                      fullpathname, prerr, slapd_pr_strerror(prerr));
-                    }
-                }
-            }
-        }
-    }
-
-    slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl, "_cl5DBOpen - "
-                                                       "Opened %d existing databases in %s\n",
-                  count, s_cl5Desc.dbDir);
-    PR_CloseDir(dir);
-
     return CL5_SUCCESS;
 }
 
@@ -2721,7 +2396,7 @@ _cl5WriteBervals(struct berval **bv, char **buff, u_int32_t *size)
 static int32_t
 _cl5CheckCSNinCL(const ruv_enum_data *element, void *arg)
 {
-    CL5DBFile *file = (CL5DBFile *)arg;
+    cldb_Handle *cldb = (cldb_Handle *)arg;
     int rc = 0;
 
     DBT key = {0}, data = {0};
@@ -2733,487 +2408,64 @@ _cl5CheckCSNinCL(const ruv_enum_data *element, void *arg)
 
     data.flags = DB_DBT_MALLOC;
 
-    rc = file->db->get(file->db, NULL /*txn*/, &key, &data, 0);
+    rc = cldb->db->get(cldb->db, NULL /*txn*/, &key, &data, 0);
 
     slapi_ch_free(&(data.data));
     return rc;
 }
 
 static int32_t
-_cl5CheckMaxRUV(CL5DBFile *file, RUV *maxruv)
+_cl5CheckMaxRUV(cldb_Handle *cldb, RUV *maxruv)
 {
     int rc = 0;
 
-    rc = ruv_enumerate_elements(maxruv, _cl5CheckCSNinCL, (void *)file);
+    rc = ruv_enumerate_elements(maxruv, _cl5CheckCSNinCL, (void *)cldb);
 
     return rc;
 }
-/* upgrade from db33 to db41
- * 1. Run recovery on the database environment using the DB_ENV->open method
- * 2. Remove any Berkeley DB environment using the DB_ENV->remove method
- * 3. Remove any Berkeley DB transaction log files
- * 4. extention .db3 -> .db4
- */
-static int
-_cl5UpgradeMajor(char *fromVersion, char *toVersion)
+static void
+_cl5Close(void)
 {
-    PRDir *dir = NULL;
-    PRDirEntry *entry = NULL;
-    DB *thisdb = NULL;
-    CL5OpenMode backup;
-    int rc = 0;
-
-    backup = s_cl5Desc.dbOpenMode;
-    s_cl5Desc.dbOpenMode = CL5_OPEN_CLEAN_RECOVER;
-    /* CL5_OPEN_CLEAN_RECOVER does 1 and 2 */
-    rc = _cl5AppInit();
-    if (rc != CL5_SUCCESS) {
-        slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                      "_cl5UpgradeMajor - Failed to open the db env\n");
-        return rc;
-    }
-    s_cl5Desc.dbOpenMode = backup;
+    PRIntervalTime interval;
 
-    dir = PR_OpenDir(s_cl5Desc.dbDir);
-    if (dir == NULL) {
-        slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                      "_cl5UpgradeMajor - Failed to open changelog dir %s; NSPR error - %d\n",
-                      s_cl5Desc.dbDir, PR_GetError());
-        goto out;
-    }
+    if (s_cl5Desc.dbState != CL5_STATE_CLOSED) /* Don't try to close twice */
+    {
 
-    while (NULL != (entry = PR_ReadDir(dir, PR_SKIP_DOT | PR_SKIP_DOT_DOT))) {
-        if (NULL == entry->name) {
-            break;
+        /* cl5Close() set the state flag to CL5_STATE_CLOSING, which should
+           trigger all of the db housekeeping threads to exit, and which will
+           eventually cause no new update threads to start - so we wait here
+           for those other threads to finish before we proceed */
+        interval = PR_MillisecondsToInterval(100);
+        while (s_cl5Desc.threadCount > 0) {
+            slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
+                          "_cl5Close -Waiting for threads to exit: %d thread(s) still active\n",
+                          s_cl5Desc.threadCount);
+            DS_Sleep(interval);
         }
-        if (_cl5FileEndsWith(entry->name, DB_EXTENSION_DB3) ||
-            _cl5FileEndsWith(entry->name, DB_EXTENSION_DB4)) {
-            char oName[MAXPATHLEN + 1];
-            char nName[MAXPATHLEN + 1];
-            char *p = NULL;
-            char c;
-            int baselen = 0;
-            PR_snprintf(oName, MAXPATHLEN, "%s/%s", s_cl5Desc.dbDir, entry->name);
-            p = strstr(oName, DB_EXTENSION_DB3);
-            if (NULL == p) {
-                p = strstr(oName, DB_EXTENSION_DB4);
-                if (NULL == p) {
-                    continue;
-                }
-            }
 
-            /* db->rename closes DB; need to create every time */
-            rc = db_create(&thisdb, s_cl5Desc.dbEnv, 0);
-            if (0 != rc) {
-                slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                              "_cl5UpgradeMajor - Failed to get db handle\n");
-                goto out;
-            }
+        /* There should now be no threads accessing any of the changelog databases -
+           it is safe to remove those databases */
+        _cl5DBClose();
 
-            baselen = p - oName;
-            c = *p;
-            *p = '\0';
-            PR_snprintf(nName, MAXPATHLEN + 1, "%s", oName);
-            PR_snprintf(nName + baselen, MAXPATHLEN + 1 - baselen, "%s", DB_EXTENSION);
-            *p = c;
-            slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                          "_cl5UpgradeMajor - Renaming %s to %s\n", oName, nName);
-            rc = thisdb->rename(thisdb, (const char *)oName, NULL /* subdb */,
-                                (const char *)nName, 0);
-            if (rc != PR_SUCCESS) {
-                slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                              "_cl5UpgradeMajor - Failed to rename file (%s -> %s); "
-                              "db error - %d %s\n",
-                              oName, nName, rc, db_strerror(rc));
-                break;
-            }
+        /* cleanup trimming */
+        _cl5TrimCleanup();
+
+        /* remove changelog if requested */
+        if (s_cl5Desc.dbRmOnClose) {
+            s_cl5Desc.dbRmOnClose = PR_FALSE;
         }
-    }
-    /* update the version file */
-    _cl5WriteDBVersion();
-    slapi_log_err(SLAPI_LOG_INFO, repl_plugin_name_cl,
-                  "_cl5UpgradeMajor - Upgrading from %s to %s is successfully done (%s)\n",
-                  fromVersion, toVersion, s_cl5Desc.dbDir);
-out:
-    if (NULL != dir) {
-        PR_CloseDir(dir);
-    }
-    return rc;
-}
-
-/* upgrade from db41 -> db42 -> db43 -> db44 -> db45
- * 1. Run recovery on the database environment using the DB_ENV->open method
- * 2. Remove any Berkeley DB environment using the DB_ENV->remove method
- * 3. Remove any Berkeley DB transaction log files
- */
-static int
-_cl5UpgradeMinor(char *fromVersion, char *toVersion)
-{
-    CL5OpenMode backup;
-    int rc = 0;
-
-    backup = s_cl5Desc.dbOpenMode;
-    s_cl5Desc.dbOpenMode = CL5_OPEN_CLEAN_RECOVER;
-    /* CL5_OPEN_CLEAN_RECOVER does 1 and 2 */
-    rc = _cl5AppInit();
-    if (rc != CL5_SUCCESS) {
-        slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                      "_cl5UpgradeMinor - Failed to open the db env\n");
-        return rc;
-    }
-    s_cl5Desc.dbOpenMode = backup;
-
-    /* update the version file */
-    _cl5WriteDBVersion();
-    slapi_log_err(SLAPI_LOG_INFO, repl_plugin_name_cl,
-                  "_cl5UpgradeMinor - Upgrading from %s to %s is successfully done (%s)\n",
-                  fromVersion, toVersion, s_cl5Desc.dbDir);
-
-    return rc;
-}
-
-static int
-_cl5CheckDBVersion(void)
-{
-    char clVersion[VERSION_SIZE + 1];
-    char dbVersion[VERSION_SIZE + 1];
-    int rc;
-
-    if (!cl5Exist(s_cl5Desc.dbDir)) {
-        /* this is new changelog - write DB version and guardian file */
-        rc = _cl5WriteDBVersion();
-    } else {
-        char *versionp = NULL;
-        char *versionendp = NULL;
-        char *dotp = NULL;
-        int dbmajor = 0;
-        int dbminor = 0;
-
-        PR_snprintf(clVersion, VERSION_SIZE, "%s/%d.%d/%s",
-                    BDB_IMPL, DB_VERSION_MAJOR, DB_VERSION_MINOR, BDB_REPLPLUGIN);
-
-        rc = _cl5ReadDBVersion(s_cl5Desc.dbDir, dbVersion, sizeof(dbVersion));
-
-        if (rc != CL5_SUCCESS) {
-            slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                          "_cl5CheckDBVersion - Invalid dbversion\n");
-            rc = CL5_BAD_DBVERSION;
-            goto bailout;
-        }
-        versionendp = dbVersion + strlen(dbVersion);
-        /* get the version number */
-        /* old DBVERSION string: CL5_TYPE/REPL_PLUGIN_NAME/#.# */
-        if (PL_strncmp(dbVersion, CL5_TYPE, strlen(CL5_TYPE)) == 0) {
-            versionp = strrchr(dbVersion, '/');
-        }
-        /* new DBVERSION string: bdb/#.#/libreplication-plugin */
-        else if (PL_strncmp(dbVersion, BDB_IMPL, strlen(BDB_IMPL)) == 0) {
-            versionp = strchr(dbVersion, '/');
-        }
-        if (NULL == versionp || versionp == versionendp) {
-            slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                          "_cl5CheckDBVersion - Invalid dbversion: %s\n", dbVersion);
-            rc = CL5_BAD_DBVERSION;
-            goto bailout;
-        }
-        dotp = strchr(++versionp, '.');
-        if (NULL != dotp) {
-            *dotp = '\0';
-            dbmajor = strtol(versionp, (char **)NULL, 10);
-            dbminor = strtol(dotp + 1, (char **)NULL, 10);
-            *dotp = '.';
-        } else {
-            dbmajor = strtol(versionp, (char **)NULL, 10);
-        }
-
-        if (dbmajor < DB_VERSION_MAJOR) {
-            /* upgrade */
-            rc = _cl5UpgradeMajor(dbVersion, clVersion);
-            if (rc != CL5_SUCCESS) {
-                slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                              "_cl5CheckDBVersion - Upgrade %s -> %s failed\n",
-                              dbVersion, clVersion);
-                rc = CL5_BAD_DBVERSION;
-            }
-        } else if (dbminor < DB_VERSION_MINOR) {
-            /* minor upgrade */
-            rc = _cl5UpgradeMinor(dbVersion, clVersion);
-            if (rc != CL5_SUCCESS) {
-                slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                              "_cl5CheckDBVersion - Upgrade %s -> %s failed\n",
-                              dbVersion, clVersion);
-                rc = CL5_BAD_DBVERSION;
-            }
-        }
-    }
-bailout:
-    return rc;
-}
-
-static int
-_cl5ReadDBVersion(const char *dir, char *clVersion, int buflen)
-{
-    int rc;
-    PRFileDesc *file;
-    char fName[MAXPATHLEN + 1];
-    char buff[BUFSIZ];
-    PRInt32 size;
-    char *tok;
-    char *iter = NULL;
-
-    if (clVersion) {
-        clVersion[0] = '\0';
-    }
-
-    PR_snprintf(fName, MAXPATHLEN, "%s/%s", dir, VERSION_FILE);
-
-    file = PR_Open(fName, PR_RDONLY, 777);
-    if (file == NULL) {
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                      "_cl5ReadDBVersion - Failed to open DBVERSION; NSPR error - %d\n",
-                      PR_GetError());
-        return CL5_SYSTEM_ERROR;
-    }
-
-    size = slapi_read_buffer(file, buff, BUFSIZ);
-    if (size < 0) {
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                      "_cl5ReadDBVersion - Failed to read DBVERSION; NSPR error - %d\n",
-                      PR_GetError());
-        PR_Close(file);
-        return CL5_SYSTEM_ERROR;
-    }
-
-    /* parse the data */
-    buff[size] = '\0';
-    tok = ldap_utf8strtok_r(buff, "\n", &iter);
-    if (tok) {
-        if (clVersion) {
-            PL_strncpyz(clVersion, tok, buflen);
-        }
-    }
-
-    rc = PR_Close(file);
-    if (rc != PR_SUCCESS) {
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                      "_cl5ReadDBVersion - Failed to close DBVERSION; NSPR error - %d\n",
-                      PR_GetError());
-        return CL5_SYSTEM_ERROR;
-    }
-
-    return CL5_SUCCESS;
-}
-
-static int
-_cl5WriteDBVersion(void)
-{
-    int rc;
-    PRFileDesc *file;
-    char fName[MAXPATHLEN + 1];
-    char clVersion[VERSION_SIZE + 1];
-    PRInt32 len, size;
-
-    PR_snprintf(fName, MAXPATHLEN, "%s/%s", s_cl5Desc.dbDir, VERSION_FILE);
-
-    file = PR_Open(fName, PR_WRONLY | PR_CREATE_FILE | PR_TRUNCATE,
-                   s_cl5Desc.dbConfig.fileMode);
-    if (file == NULL) {
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                      "_cl5WriteDBVersion - Failed to open DBVERSION; NSPR error - %d\n",
-                      PR_GetError());
-        return CL5_SYSTEM_ERROR;
-    }
-
-    /* write changelog version */
-    PR_snprintf(clVersion, VERSION_SIZE, "%s/%d.%d/%s\n",
-                BDB_IMPL, DB_VERSION_MAJOR, DB_VERSION_MINOR, BDB_REPLPLUGIN);
-
-    len = strlen(clVersion);
-    size = slapi_write_buffer(file, clVersion, len);
-    if (size != len) {
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                      "_cl5WriteDBVersion - Failed to write DBVERSION; NSPR error - %d\n",
-                      PR_GetError());
-        PR_Close(file);
-        return CL5_SYSTEM_ERROR;
-    }
-
-    rc = PR_Close(file);
-    if (rc != PR_SUCCESS) {
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                      "_cl5WriteDBVersion - Failed to close DBVERSION; NSPR error - %d\n",
-                      PR_GetError());
-        return CL5_SYSTEM_ERROR;
-    }
-
-    return CL5_SUCCESS;
-}
-
-/* must be called under the state lock */
-static void
-_cl5Close(void)
-{
-    PRIntervalTime interval;
-
-    if (s_cl5Desc.dbState != CL5_STATE_CLOSED) /* Don't try to close twice */
-    {
-
-        /* cl5Close() set the state flag to CL5_STATE_CLOSING, which should
-           trigger all of the db housekeeping threads to exit, and which will
-           eventually cause no new update threads to start - so we wait here
-           for those other threads to finish before we proceed */
-        interval = PR_MillisecondsToInterval(100);
-        while (s_cl5Desc.threadCount > 0) {
-            slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                          "_cl5Close -Waiting for threads to exit: %d thread(s) still active\n",
-                          s_cl5Desc.threadCount);
-            DS_Sleep(interval);
-        }
-
-        /* There should now be no threads accessing any of the changelog databases -
-           it is safe to remove those databases */
-        _cl5DBClose();
-
-        /* cleanup trimming */
-        _cl5TrimCleanup();
-
-        /* remove changelog if requested */
-        if (s_cl5Desc.dbRmOnClose) {
-
-            if (_cl5Delete(s_cl5Desc.dbDir, 1) != CL5_SUCCESS) {
-                slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                              "cl5Close - Failed to remove changelog\n");
-            }
-            s_cl5Desc.dbRmOnClose = PR_FALSE;
-        }
-
-        slapi_ch_free((void **)&s_cl5Desc.dbDir);
-        memset(&s_cl5Desc.dbConfig, 0, sizeof(s_cl5Desc.dbConfig));
-        s_cl5Desc.fatalError = PR_FALSE;
-        s_cl5Desc.threadCount = 0;
-        s_cl5Desc.dbOpenMode = CL5_OPEN_NONE;
+
+        memset(&s_cl5Desc.dbConfig, 0, sizeof(s_cl5Desc.dbConfig));
+        s_cl5Desc.fatalError = PR_FALSE;
+        s_cl5Desc.threadCount = 0;
+        s_cl5Desc.dbOpenMode = CL5_OPEN_NONE;
     }
 }
 
 static void
 _cl5DBClose(void)
 {
-    if (NULL != s_cl5Desc.dbFiles) {
-        Object *obj;
-        for (obj = objset_first_obj(s_cl5Desc.dbFiles); obj;
-             obj = objset_next_obj(s_cl5Desc.dbFiles, obj)) {
-            slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                          "_cl5DBClose - Deleting DB object %p\n", obj);
-        }
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                      "_cl5DBClose - Closing databases in %s\n", s_cl5Desc.dbDir);
-        objset_delete(&s_cl5Desc.dbFiles);
-    }
-    if (NULL != s_cl5Desc.fileLock) {
-        PR_DestroyLock(s_cl5Desc.fileLock);
-        s_cl5Desc.fileLock = NULL;
-    }
-}
-
-/* see if the given file is a changelog db file */
-static int
-_cl5IsDbFile(const char *fname)
-{
-    if (!fname || !*fname) {
-        return 0;
-    }
-
-    if (!strcmp(fname, VERSION_FILE)) {
-        return 1;
-    }
-
-    if (_cl5FileEndsWith(fname, DB_EXTENSION)) {
-        return 1;
-    }
-
-    return 0; /* not a filename we recognize as being associated with the db */
-}
-
-/* state lock must be locked */
-static int
-_cl5Delete(const char *clDir, int rmDir)
-{
-    PRDir *dir;
-    char filename[MAXPATHLEN + 1];
-    PRDirEntry *entry = NULL;
-    int rc;
-    int dirisempty = 1;
-
-    /* remove all files in the directory and the directory */
-    dir = PR_OpenDir(clDir);
-    if (dir == NULL) {
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                      "_cl5Delete - Failed to open changelog dir; NSPR error - %d\n",
-                      PR_GetError());
-        return CL5_SYSTEM_ERROR;
-    }
-
-    while (NULL != (entry = PR_ReadDir(dir, PR_SKIP_DOT | PR_SKIP_DOT_DOT))) {
-        if (NULL == entry->name) {
-            break;
-        }
-        if (!_cl5IsDbFile(entry->name)) {
-            slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                          "_cl5Delete - Skipping file [%s/%s] because it is not a changelogdb file.\n",
-                          clDir, entry->name);
-            dirisempty = 0; /* skipped at least one file - dir not empty */
-            continue;
-        }
-        PR_snprintf(filename, MAXPATHLEN, "%s/%s", clDir, entry->name);
-        /* _cl5Delete deletes the whole changelog directory with all the files
-         * underneath.  Thus, we can just remove them physically. */
-        if (0 == strcmp(entry->name, VERSION_FILE)) {
-            /* DBVERSION */
-            rc = PR_Delete(filename) != PR_SUCCESS;
-            if (PR_SUCCESS != rc) {
-                slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                              "_cl5Delete - Failed to remove \"%s\"; NSPR error - %d\n",
-                              filename, PR_GetError());
-            }
-        } else {
-            /* DB files */
-            rc = s_cl5Desc.dbEnv->dbremove(s_cl5Desc.dbEnv, 0, filename, 0,
-                                           DEFAULT_DB_ENV_OP_FLAGS);
-            if (rc) {
-                slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                              "_cl5Delete - Failed to remove \"%s\"; "
-                              "libdb error - %d (%s)\n",
-                              filename, rc, db_strerror(rc));
-            }
-        }
-    }
-
-    rc = PR_CloseDir(dir);
-    if (rc != PR_SUCCESS) {
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                      "_cl5Delete - Failed to close changelog dir (%s); NSPR error - %d\n",
-                      clDir, PR_GetError());
-        return CL5_SYSTEM_ERROR;
-    }
-
-    if (rmDir && dirisempty) {
-        rc = PR_RmDir(clDir);
-        if (rc != 0) {
-            slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                          "_cl5Delete - Failed to remove changelog dir (%s); errno = %d\n",
-                          clDir, errno);
-            return CL5_SYSTEM_ERROR;
-        }
-    } else if (rmDir && !dirisempty) {
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                      "_cl5Delete - Changelog dir (%s) is not empty - cannot remove\n",
-                      clDir);
-    }
-
-    /* invalidate the clcache */
-    clcache_destroy();
-
-    return CL5_SUCCESS;
+    replica_enumerate_replicas(_cl5WriteReplicaRUV, NULL);
 }
 
 static void
@@ -3229,7 +2481,6 @@ _cl5SetDBConfig(const CL5DBConfig *config)
     /* Some other configuration parameters are hardcoded... */
     s_cl5Desc.dbConfig.fileMode = FILE_CREATE_MODE;
 }
-
 /* Trimming helper functions */
 static int
 _cl5TrimInit(void)
@@ -3308,30 +2559,31 @@ _cl5TrimMain(void *param __attribute__((unused)))
  *   change sent to the consumer in the changelog and will fail because the
  *   change was removed.
  */
-static void
-_cl5DoTrimming(void)
+int
+_cl5TrimReplica(Replica *r, void *arg)
 {
-    Object *obj;
     long numToTrim;
 
-    PR_Lock(s_cl5Desc.dbTrim.lock);
+    if (_cl5CanTrim ((time_t)0, &numToTrim, r) ) {
+        _cl5TrimFile (r, &numToTrim);
+    }
+    return 0;
+}
+
+static void
+_cl5DoTrimming(void)
+{
+    PR_Lock (s_cl5Desc.dbTrim.lock);
 
     /*
-     * We are trimming all the changelogs.  We trim file by file which
-     * means that some files will be trimmed more often than other. We
-     * might have to fix that by, for example, randomizing the starting
-     * point.
+     *          * We are trimming all the changelogs.  We trim file by file which
+     *                   * means that some files will be trimmed more often than other. We
+     *                            * might have to fix that by, for example, randomizing the starting
+     *                                     * point.
      */
-    obj = objset_first_obj(s_cl5Desc.dbFiles);
-    while (obj && _cl5CanTrim((time_t)0, &numToTrim)) {
-        _cl5TrimFile(obj, &numToTrim);
-        obj = objset_next_obj(s_cl5Desc.dbFiles, obj);
-    }
-
-    if (obj)
-        object_release(obj);
 
-    PR_Unlock(s_cl5Desc.dbTrim.lock);
+    replica_enumerate_replicas(_cl5TrimReplica, NULL);
+    PR_Unlock (s_cl5Desc.dbTrim.lock);
 
     return;
 }
